package net.sf.corn.converter.json;

import net.sf.corn.converter.AbstractConverter;

/**
 * Abstract base transformer class for JSON Converters
 * 
 * @author Serhat Dirik
 */
public abstract class AbstractJsonConverter extends AbstractConverter<JsTypeObject>
		implements IJsonConverter {
	@Override
	protected final boolean isNullType(JsTypeObject obj){
		return obj == null || obj.isNull();
	}
	@Override
	protected final JsTypeObject getNullType(){
		return JsTypeNull.NULL;
	}

	protected final void addIfExist(String className){
		try{
			getConvertibles().add(Class.forName(className));
		}catch(Exception e){
		}
	}
}
