package net.sf.corn.converter.json;

import net.sf.corn.converter.ConversionException;
import net.sf.corn.converter.ObjectReferenceMap;


 class CnvChar extends AbstractJsonConverter {

	 CnvChar() {
		getConvertibles().add(char.class);
		getConvertibles().add(Character.class);
	}

	@Override
	protected JsTypeObject inToTarget(Object o, ObjectReferenceMap referenceMap)
			throws ConversionException {
		String val = o instanceof String?(String)o:o.toString();
		return new JsTypeSimple(JsTypeObject.quote(val),o.getClass().getName());
	}

	@Override
	protected Object inToJava(Class<?> clazz, JsTypeObject obj)
			throws ConversionException {
		if(! obj.isSimple()){
			throw new ConversionException("Only simple type is allowed");
		}
		return new Character(obj.toStringValue().charAt(0));
		
	}

	@Override
	public boolean isSubjectForCircularReferenceCheck() {
		return false;
	}



}
