package net.sf.corn.converter.json;

import net.sf.corn.converter.ConversionException;
import net.sf.corn.converter.ObjectReferenceMap;
import static net.sf.corn.converter.json.IJsonConstants.*;
class CnvDate extends AbstractJsonConverter {

	CnvDate() {
		getConvertibles().add(java.util.Date.class);
		getConvertibles().add(java.sql.Date.class);
		getConvertibles().add(java.sql.Time.class);
		getConvertibles().add(java.sql.Timestamp.class);
	}

	@Override
	protected JsTypeObject inToTarget(Object o, ObjectReferenceMap referenceMap)
			throws ConversionException {
		JsTypeComplex jsonObject = new JsTypeComplex(o.getClass());
		java.util.Date dt = (java.util.Date) o;
		JsonConverter transformer = new JsonConverter();
		jsonObject.put(ATTR_TIME,	transformer.toTargetType(dt.getTime(), referenceMap));
		return jsonObject;
	}

	@Override
	protected Object inToJava(Class<?> clazz, JsTypeObject obj)
			throws ConversionException {
		
		if (!obj.isComplex()) {
			throw new ConversionException("Only complex type is allowed");
		}
		JsTypeComplex jso = (JsTypeComplex) obj;
		if ( !jso.has(ATTR_TIME)){
			throw new ConversionException(ATTR_TIME + " attribute not found");
		}
		Long time = 0l;
		time = Long.valueOf(jso.get(ATTR_TIME).toStringValue());
		if (clazz.equals(java.util.Date.class)) {
			return new java.util.Date(time);
		} else if (clazz.equals(java.sql.Date.class)) {
			return new java.sql.Date(time);
		} else if (clazz.equals(java.sql.Time.class)) {
			return new java.sql.Time(time);
		} else if (clazz.equals(java.sql.Timestamp.class)) {
			return new java.sql.Timestamp(time);
		} else {
			try {
				java.util.Date dt = (java.util.Date) clazz.newInstance();
				dt.setTime(time);
				return dt;
			} catch (InstantiationException e) {
				throw new IllegalArgumentException(e);
			} catch (IllegalAccessException e) {
				throw new IllegalArgumentException(e);
			}
		}
	}

	@Override
	public boolean isConvertible(Class<?> clazz) {
		boolean ret = checkIfConvertibleFromRegisteredTypes(clazz);
		if (!ret) {
			ret = java.util.Date.class.isAssignableFrom(clazz);
		}
		return ret;
	}

	@Override
	public boolean isSubjectForCircularReferenceCheck() {
		return false;
	}
}
